.386
.model flat, stdcall
option casemap:none

include     \masm32\include\windows.inc
include     \masm32\include\user32.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\advapi32.inc
include     \masm32\include\oleaut32.inc
include     \masm32\include\ole32.inc

include     \masm32\COM\include\oaidl.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\advapi32.lib
includelib  \masm32\lib\oleaut32.lib
includelib  \masm32\lib\ole32.lib

include \masm32\macros\macros.asm
include \masm32\include\gdi32.inc
include \masm32\include\masm32.inc

includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\masm32.lib

include		use_gsm.inc

.data
;	sIID_IMyCom       GUID   {02a92b37eh, 07e00h, 04a56h,\ 
;   	                          {09dh, 0f0h, 038h, 06dh, 076h, 07h, 096h, 0f5h}}
;	sLIBID_MyComLib   GUID   {08a22c828h, 0ff87h, 04837h,\ 
;   	                          {086h, 0d6h, 0b0h, 098h, 0a6h, 0b9h, 08bh, 055h}}
	sCLSID_MyCom      GUID   {065885d44h, 0224bh, 04ae3h,\ 
    	                         {08ch, 012h, 03eh, 0feh, 0b4h, 05ah, 0f4h,05bh}}
	IID_IUnknown        GUID    sIID_IUnknown
	ppv		 DWORD   ?

	table		BYTE		'0123456789ABCDEF'
	Kc			BYTE		8 dup(?)
	count		DWORD		0

	hIn			DWORD		?
	hOut		DWORD		?
	fnKey		BYTE		"key.txt",0
	fnText		BYTE		"in.txt",0
	fnOut		BYTE		"out.txt",0
	buf			BYTE		16 dup(?)
	buf_text	BYTE		57 dup(0)
	cRead		DWORD		?

.code
start:
		call main
	exit
	
main proc

	LOCAL	count_b[5]:BYTE
	
	invoke	CreateFile, addr fnKey,GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
	mov		hIn, eax
	
	invoke	ReadFile, hIn, addr buf, 16, addr cRead, NULL
	mov		esi, 0					; Chitaem iz fajla stroku - kluch Kc, perevodim ee v massiv byte
	mov		ecx, 8
	L_str2hex:
		push	ecx
		mov		ecx, 16
		mov		ebx, 0
		mov		edi, offset table
		mov		al, buf[esi*2]
		repnz	scasb
		sub		edi, offset table+1
		mov		ebx, edi
		shl		ebx, 4
		mov		edi, offset table
		mov		al, buf[esi*2+1]
		mov		ecx, 16
		repnz	scasb
		sub		edi, offset table+1
		add		ebx, edi
		mov		Kc[esi], bl
		add		esi, 1
		pop		ecx
		loop L_str2hex

	invoke	ReadFile, hIn, addr buf, 2, addr cRead, NULL
	invoke	ReadFile, hIn, addr buf, 8, addr cRead, NULL
	mov		esi, 0					; Chitaem iz fajla stroku - nomer kadra, perevodim ee v DWORD
	mov		ecx, 4
	L_s2h:
		push	ecx
		mov		ecx, 16
		mov		ebx, 0
		mov		edi, offset table
		mov		al, buf[esi*2]
		repnz	scasb
		sub		edi, offset table+1
		mov		ebx, edi
		shl		ebx, 4
		mov		edi, offset table
		mov		al, buf[esi*2+1]
		mov		ecx, 16
		repnz	scasb
		sub		edi, offset table+1
		add		ebx, edi
		add		esi, 1
		pop		ecx
		mov		count_b[ecx], bl
		loop L_s2h
	mov		count_b[4], 0
	mov		eax, dword ptr count_b[1]
	mov		count, eax

	invoke	CloseHandle, hIn

	invoke CoInitialize,NULL
	invoke CoCreateInstance,addr sCLSID_MyCom,NULL,CLSCTX_INPROC_SERVER,addr IID_IUnknown,addr ppv

	invoke	CreateFile, addr fnText,GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
	mov		hIn, eax
	
	invoke	CreateFile, addr fnOut,GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_ARCHIVE, 0
	mov		hOut, eax
	
	mov		ecx,1
	L_rf:						; a big looooop, reading input file, 4 114-bit frames per pass
		push	ecx
		
		mov		ecx, 56
		L_cleanarr:
			mov		buf_text[ecx], 0
			loop L_cleanarr
		mov		buf_text[0], 0

		invoke	ReadFile, hIn, addr buf_text, 57, addr cRead, NULL	
		
		cmp		cRead, 0
		je		L_eof

		mov edx,ppv
		mov edx,[edx]
		invoke Call_GSM
		
		add		count, 4
		
		mov edx,ppv
		mov edx,[edx]
		invoke Call_Enc_Dec
	
		invoke WriteFile, hOut, addr buf_text, cRead, addr cRead, NULL 
	
		pop		ecx
		add		ecx, 1
		loop L_rf

	L_eof:
	invoke CoUninitialize
	invoke	CloseHandle, hIn
	invoke	CloseHandle, hOut

	ret
main endp

PrintArr proc arr:PTR BYTE, l: DWORD

	mov		edi, arr
	mov		eax, 0
	mov		ecx, l
	mov		ebx, 0
	L_arr:
		push	ecx
		push	ebx
		mov		al, [edi][ebx]
		print	hex$(eax)
		print	chr$(10,13)
		pop		ebx
		add		ebx, 1
		pop		ecx
		loop L_arr		
	ret

PrintArr endp

Call_GSM proc
	
	push count
	push 64
	push offset Kc
	push offset ppv
	call DWORD ptr [edx+12]
	
	ret

Call_GSM endp

Call_Enc_Dec proc
	
	push offset buf_text
	push offset ppv
	call DWORD ptr [edx+16]
	
	ret

Call_Enc_Dec endp

end start

