;--------------------------------------------------------------------------
; MyCom.dll     ActiveX server
;--------------------------------------------------------------------------
.386
.model flat, stdcall
option casemap:none
.NOLIST
;--------------------------------------------------------------------------

include     \masm32\include\windows.inc
include     \masm32\include\user32.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\advapi32.inc
include     \masm32\include\oleaut32.inc
include     \masm32\include\ole32.inc

include     \masm32\COM\include\oaidl.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\advapi32.lib
includelib  \masm32\lib\oleaut32.lib
includelib  \masm32\lib\ole32.lib

include		gsm.asm

;--------------------------------------------------------------------------
.LISTALL

;------------------------------------------------------------------------------------

;sIID_IMyCom       TEXTEQU   <{02a92b37eh, 07e00h, 04a56h,     \ 
;                             {09dh, 0f0h, 038h, 06dh, 076h, 07h, 096h, 0f5h}}>
;sLIBID_MyComLib   TEXTEQU   <{08a22c828h, 0ff87h, 04837h,    \ 
;                             {086h, 0d6h, 0b0h, 098h, 0a6h, 0b9h, 08bh, 055h}}>
sCLSID_MyCom      TEXTEQU   <{065885d44h, 0224bh, 04ae3h,     \ 
                             {08ch, 012h, 03eh, 0feh, 0b4h, 05ah, 0f4h,05bh}}>

_vtIMyCom MACRO CastName:REQ
    _vtIUnknown CastName
    &CastName&_Message1     comethod2   ?
    &CastName&_Message2     comethod2   ?
ENDM

IMyCom                   STRUCT
    _vtIMyCom IMyCom
IMyCom                   ENDS

;--------------------------------------------------------------------------
DllCanUnloadNow         PROTO
DllGetClassObject       PROTO :DWORD, :DWORD, :DWORD

QueryInterface_CF       PROTO :DWORD, :DWORD, :DWORD
AddRef_CF               PROTO :DWORD
Release_CF              PROTO :DWORD
QueryInterface_MC       PROTO :DWORD, :DWORD, :DWORD
AddRef_MC               PROTO :DWORD
Release_MC              PROTO :DWORD

CreateInstance          PROTO :DWORD, :DWORD, :DWORD, :DWORD
GSM 					PROTO :DWORD, :PTR BYTE, :BYTE, :DWORD
Enc_Dec					PROTO :DWORD, :PTR BYTE

CreateMyComObject       PROTO 


ClassFactoryObject  STRUCT 
    lpVtbl          DWORD       0
    nRefCount       DWORD       1  
ClassFactoryObject  ENDS


MyComObject         STRUCT 
    lpVtbl          DWORD	0
    nRefCount       DWORD	1
    nValue          BYTE	60 dup (?)
MyComObject         ENDS

;-----------------------------------------------------------------------------
.data

vtIClassFactory   IClassFactory     <   QueryInterface_CF,      \
                                        AddRef_CF,              \
                                        Release_CF,             \
                                        CreateInstance,         \
                                        LockServer       >

vtIMyCom          IMyCom            <   QueryInterface_MC,      \
                                        AddRef_MC,              \
                                        Release_MC,             \
                                        GSM,				 	\
                                        Enc_Dec			>

MyCFObject        ClassFactoryObject<   OFFSET vtIClassFactory, \
                                        0                >
;IID_IMyCom          GUID    sIID_IMyCom
CLSID_MyCom         GUID    sCLSID_MyCom
;TYPELIB_MyCom       GUID    sLIBID_MyComLib
IID_IUnknown        GUID    sIID_IUnknown
IID_IClassFactory   GUID    sIID_IClassFactory

g_hDllMain          DWORD   0 


;--------------------------------------------------------------------------
.code

;--------------------------------------------------------------------------
DllMain PROC hModule:HANDLE, dwReason:DWORD, lpReserved:DWORD
    .IF dwReason == DLL_PROCESS_ATTACH
        mov eax, hModule
        mov g_hDllMain, eax
        mov eax, TRUE
    .ELSEIF
        mov eax, FALSE
    .ENDIF
    ret
DllMain Endp

;--------------------------------------------------------------------------
DllCanUnloadNow PROC
    .IF (MyCFObject.nRefCount == 0)
        mov eax, TRUE
    .ELSEIF
        mov eax, FALSE
    .ENDIF
    ret
DllCanUnloadNow Endp

;--------------------------------------------------------------------------
DllGetClassObject PROC pCLSID:DWORD, pIID:DWORD, ppv:DWORD
    LOCAL   hr        :DWORD
    LOCAL   pFactory  :DWORD
    invoke  IsEqualGUID, pCLSID, addr CLSID_MyCom
    .IF (eax == TRUE)
         mov eax, OFFSET MyCFObject
        invoke QueryInterface_CF, eax, pIID, ppv
         mov hr, eax
        invoke Release_CF, OFFSET MyCFObject
    .ELSE
        mov hr, CLASS_E_CLASSNOTAVAILABLE
    .ENDIF  
    mov eax, hr
    ret
DllGetClassObject Endp

;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
QueryInterface_CF PROC this_:DWORD, pRIID:DWORD,  ppv:DWORD
    LOCAL Match:DWORD
    invoke  IsEqualGUID, pRIID, addr IID_IUnknown
    mov Match, eax
    invoke  IsEqualGUID, pRIID, addr IID_IClassFactory
    or eax, Match    
    .IF (eax == TRUE)
                                ; both of which we are & support
        mov eax, this_          
        mov edx, ppv
        mov [edx], eax          ; so we point to ourselves
        invoke AddRef_CF, eax   ; inc the ref count for the new pointer *we* created     
        xor eax, eax            ; and signal all is well (same as 'ret S_OK')
        jmp return
    .ENDIF      
NoInterface:
    mov [ppv], NULL
    mov eax, E_NOINTERFACE
return: 
    ret
QueryInterface_CF endp

;-----------------------------------------------------------------------------
AddRef_CF proc this_:DWORD
    inc MyCFObject.nRefCount
    mov eax, MyCFObject.nRefCount
    ret         ; note we return the object count
AddRef_CF endp

;-----------------------------------------------------------------------------
Release_CF proc this_:DWORD
    dec MyCFObject.nRefCount  
    mov eax, MyCFObject.nRefCount
    ret         ; note we return the object count
Release_CF endp

;-----------------------------------------------------------------------------
CreateInstance PROC this_:DWORD, pUnknownOuter:DWORD, iid:DWORD, ppv:DWORD
    LOCAL   pMyObject:DWORD
    LOCAL   hr:DWORD
    .IF pUnknownOuter != NULL
        mov eax, CLASS_E_NOAGGREGATION
    .ELSE
    
    	.IF MyCFObject.nRefCount != 1			; Esli kto-to hochet sozdat' esche 1 object, govorim, chto net pamyati.
    		mov		eax, E_OUTOFMEMORY
		.ENDIF
		    
        invoke CreateMyComObject
        mov pMyObject, eax
        .IF eax == NULL                
            mov eax, E_OUTOFMEMORY
        .ELSE
            inc MyCFObject.nRefCount
            invoke QueryInterface_MC, pMyObject, iid, ppv
            mov hr, eax
            invoke Release_MC,  pMyObject
        .ENDIF
    .ENDIF
    mov eax, hr
    ret
CreateInstance ENDP

;-----------------------------------------------------------------------------
LockServer PROC pif:DWORD, bLockServer:DWORD
    .IF bLockServer == TRUE
        inc MyCFObject.nRefCount
    .ELSE
        dec MyCFObject.nRefCount
    .ENDIF
    mov eax, S_OK
    ret    
LockServer ENDP

;-----------------------------------------------------------------------------
CreateMyComObject PROC
    LOCAL   pNewObject:DWORD
    invoke  CoTaskMemAlloc, sizeof MyComObject
    mov pNewObject, eax
    .IF (eax != NULL)
        mov edx, pNewObject
        mov (MyComObject PTR [edx]).lpVtbl, OFFSET vtIMyCom
        mov (MyComObject PTR [edx]).nRefCount, 1
        
        mov		ecx, 60
        L_cleanarr:
			mov		(MyComObject PTR [edx]).nValue[ecx], 0
			loop L_cleanarr
        ;mov (MyComObject PTR [edx]).nValue, 0

 	 .ENDIF
    mov eax, pNewObject
    ret
CreateMyComObject endp

;-----------------------------------------------------------------------------
QueryInterface_MC PROC this_:DWORD, pRIID:DWORD,  ppv:DWORD
    LOCAL Match     :DWORD
    LOCAL ppvt      :DWORD
    invoke  IsEqualGUID, pRIID, addr IID_IUnknown
    mov Match, eax
;    invoke  IsEqualGUID, pRIID, addr IID_IMyCom
;    or eax, Match
    .IF (eax == TRUE)          
        mov eax, this_          
        mov edx, ppv
        mov [edx], eax 
        mov ppvt, eax
        invoke AddRef_MC, ppvt   
        mov eax, S_OK 
        jmp return
    .ENDIF    
NoInterface:
    xor eax, eax               
    mov edx, ppv   
    mov [edx], eax  
    mov eax, E_NOINTERFACE 
return: 
    ret
QueryInterface_MC endp

;-----------------------------------------------------------------------------
AddRef_MC proc this_:DWORD
    mov eax, this_
    inc (MyComObject ptr [eax]).nRefCount
    mov eax, (MyComObject ptr [eax]).nRefCount
    ret 
AddRef_MC endp

;-----------------------------------------------------------------------------
Release_MC proc this_:DWORD
    mov eax, this_
    dec (MyComObject ptr [eax]).nRefCount
    mov eax, (MyComObject ptr [eax]).nRefCount
    .IF (eax == 0)
        invoke  CoTaskMemFree, this_
        dec MyCFObject.nRefCount
        xor eax, eax
    .ENDIF
    ret 
Release_MC endp

;-----------------------------------------------------------------------------


End DllMain
